//Dieses Miniprogramm ist ein Beispiel fr das einbauen von Assembler-Code in D. Beim einbauen von Assembler sollte man stets vorsichtig sein, ich wei nicht, ob und wie D auf Sicherheit dabei achtet.
import std.stdio;

void main()
{
    int x = 6;
    int y = 7;
    int ergebnis = 0;
    //"version" ist vergleichbar mit "IFDEF xx" in C, so ist es zum Beispiel mglich mit "version(Windows)" und "version(Linux)" betriebssystemspezifische Dinge zu programmieren.
    version (D_InlineAsm_X86)
    {
        //Im "asm" Block schreibt man den Assemblercode. Im Gegensatz zu der Assemblerprogrammierung, die ich in RS kennengelernt habe, muss man hier Zeilen, bzw. Anweisungen mit einem Semikolon trennen. "x", "y" und "ergebnis" werden brigens vom Compiler geeignet Interpretiert.
        asm
        {
            mov EAX, x          ;//"Kopiere den Inhalt von x ins Register EAX"
            mul EAX, y          ;//"Multipliziere den Inhalt von EAX und y und schreibe das Ergebnis ins Register EAX"
            mov ergebnis, EAX   ;//"Kopiere den Inhalt von EAX nach ergebnis"
        }
    }
    //Wenn die Rechnung (hoffentlich korrekt) ausgefhrt wurde
    if(ergebnis != 0)
    {
        write("Das Produkt aus ", x, " und ", y, " ist ", ergebnis, ".");
    }
    //sonst
    else
    {
        write("Das hat nicht funktioniert");
    }
}